﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using C1.WPF.C1Chart;
using System.Windows.Controls.Primitives;

namespace Wpf_Chart_KeyboardShortcuts_CS
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            CreateSampleData();
            Chart1.MouseLeftButtonDown += new MouseButtonEventHandler(Chart1_MouseLeftButtonDown);
            Chart1.PreviewKeyDown += new KeyEventHandler(Chart1_PreviewKeyDown);
        }

        void Chart1_PreviewKeyDown(object sender, KeyEventArgs e)
        {
            Chart1.View.AxisX.MinScale = 0.001;
            Chart1.View.AxisY.MinScale = 0.001;
            if ((e.Key == Key.Down))
            {
                Chart1.BeginUpdate();
                Chart1.View.AxisX.Scale = (Chart1.View.AxisX.Scale - 0.35);
                Chart1.View.AxisY.Scale = (Chart1.View.AxisY.Scale - 0.35);
                UpdateScrollbars();
                Chart1.EndUpdate();
            }
            else if ((e.Key == Key.Up))
            {
                Chart1.BeginUpdate();
                Chart1.View.AxisX.Scale = (Chart1.View.AxisX.Scale + 0.35);
                Chart1.View.AxisY.Scale = (Chart1.View.AxisY.Scale + 0.35);
                UpdateScrollbars();
                Chart1.EndUpdate();
            }
            else if ((e.Key == Key.Escape))
            {
                Chart1.BeginUpdate();
                Chart1.View.AxisX.Scale = 1;
                Chart1.View.AxisY.Scale = 1;
                UpdateScrollbars();
                Chart1.EndUpdate();
            }
        }

        void Chart1_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            Chart1.Focus();
        }

        private void CreateSampleData()
        {
            DataSeriesCollection chartDataChildren = new DataSeriesCollection();
            int npts = 10;
            double[] x= new double[npts];
            double[] y = new double[npts];
            for (int i = 0; (i <= 9); i++)
            {
                x[i] = ((i + 1) * 50);
                y[i] = ((i + 1) * 100);
            }
            XYDataSeries XY = new XYDataSeries();
            XY.Label = "S1";
            XY.XValuesSource = x;
            XY.ValuesSource = y;
            Chart1.Data.Children.Add(XY);
        }
        private void UpdateScrollbars()
        {
            double sx = Chart1.View.AxisX.Scale;
            AxisScrollBar sbx = ((AxisScrollBar)(Chart1.View.AxisX.ScrollBar));
            if ((sx >= 1))
            {
                sbx.Visibility = Visibility.Collapsed;
            }
            else
            {
                sbx.Visibility = Visibility.Visible;
            }
            double sy = Chart1.View.AxisY.Scale;
            AxisScrollBar sby = ((AxisScrollBar)(Chart1.View.AxisY.ScrollBar));
            if ((sy >= 1))
            {
                sby.Visibility = Visibility.Collapsed;
            }
            else
            {
                sby.Visibility = Visibility.Visible;
            }
        }
    }
}
